<?php
/*
  boss search by Christian Heilmann
  Version: 1.0
  Homepage: http://ydntest.com/ydnblogsearch
  Copyright (c) 2008, Christian Heilmann
  Code licensed under the BSD License:
  http://wait-till-i.com/license.txt
*/

if($appID === ''){
  echo '<h2>No application ID found, <a href="https://developer.yahoo.com/wsregapp/">get an ID</a> and edit the configuration file!</h2>';
} else {

// predefine start as zero and overwrite if there is a start defined 
// make sure that the start property is numeric and nothing else.
  $start = 0;
  if(isset($_GET['start']) && preg_match("/[0-9]+/",$_GET['start'])){
    $start = $_GET['start'];
  }

// get the search term and define a filter mechanism for illegal terms.
$term = $_GET['s'];
$word = "/^[a-z|A-Z|0-9| |-|\"]+$/";

// if a term is defined...
  if(isset($term) && $term!==''){
 
// if the term has illegal characters, display an error message 
    if(!preg_match($word,$term)){
      echo '<h2>'.$badtermmessage.'</h2>';

// otherwise let's go for it
    } else {

// assemble the BOSS API call url and get the XML version of the data
      $url = 'http://boss.yahooapis.com/ysearch/web/v1/'.
              urlencode($term) . '?appid=' . $appID . '&view=keyterms&sites='.
              urlencode($sites).'&'.'format=xml&start='.$start;
      $terms = get($url);

// convert the XML string into ab object structure
      $feed = new SimpleXMLElement($terms);

// get the amount of results
      $all = $feed->resultset_web[totalhits];

// if there are no results, display the no results message
      if($all < 1){
        echo '<p id="resultcounter">'.$noresultsmessage.'</p>';

// otherwise display the results message and replace the placeholders
// with the real data
      } else {
        $resultsmessage = str_replace('$start',$start+1,$resultsmessage);
        $end = $all >$start+10 ? $start+10 : $all;
        $resultsmessage = str_replace('$end',$end,$resultsmessage);
        $resultsmessage = str_replace('$all',$all,$resultsmessage);
        echo '<p id="resultcounter">'.$resultsmessage.'</p>';
      }

// display the results list 
      echo '<ul id="results">';

// loop over all the results and display the right data
      foreach($feed->resultset_web->result as $result){
        echo '<li><h2><a href="'.$result->clickurl.'">'.$result->title.
             '</a></h2><p>'.$result->abstract.'</p><p class="kw">'.
             $keywordslabel.'</p>';
        echo '<ul>';

// get the keywords for the term and display them as a nested list to 
// allow for refining the search
        foreach ($result->keyterms->terms->term as $keyterm){
          echo '<li><a href="'.$filename.'?s='.$term.'+'.urlencode($keyterm).
               '">'.$keyterm.'</a></li>';
        }
        echo '</ul></li>';
      };

// end the output list
      echo '</ul>';

// if there are a previous or next page url returned from the API start the 
// pagination list
      if($feed->prevpage || $feed->nextpage){
        echo '<ul id="nav">';
      }

// if there is a previous page, display a previous link
      if($feed->prevpage){
        $start = split('=',$feed->prevpage);
        echo '<li><a href="'.$filename.'?s='.$term.'&start='.
              $start[sizeof($start)-1].'">'.$previouslabel.'</a>';
        echo '</li>';
      }

// if there is a next page, display a next link
      if($feed->nextpage){
        $start = split('=',$feed->nextpage);
        echo '<li><a href="'.$filename.'?s='.$term.'&start='.
              $start[sizeof($start)-1].'">'.$nextlabel.'</a></li>';
      }

// close the pagination list
      if($feed->prevpage || $feed->nextpage){
        echo '</ul>';
      }
    } 
  }
}
// use curl to get the API data
function get($url){
  $ch = curl_init();
  curl_setopt($ch, CURLOPT_URL, $url);
  curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
  $feed = curl_exec($ch);
  curl_close($ch);
  
  // for some reason SIMPLEXML doesn't like cdata around the terms,
  // so let's remove it.
  $feed = str_replace("/<term><!\[CDATA\[/",'<term>',$feed);
  $feed = str_replace("/\]\]><\/term>/",'</term>',$feed);
  return $feed;
}

